## sikuli 1.0~x~rc3-dfsg1

=== debian/changelog ===
sikuli (1.0~x~rc3-dfsg1-3build1) precise; urgency=low

  * Rebuild for opencv 2.3 transition

 -- Adrien Cunin <adri2000@ubuntu.com>  Mon, 13 Feb 2012 23:49:03 +0100

sikuli (1.0~x~rc3-dfsg1-3) unstable; urgency=low

  [ Torsten Werner ]
  * Improve executable-wrappers.patch to add asm3-commons.jar to
    runtime CLASSPATH. (Closes: #643563)

 -- Gilles Filippini <pini@debian.org>  Thu, 10 Nov 2011 22:37:06 +0100

sikuli (1.0~x~rc3-dfsg1-2) unstable; urgency=low

  * New patch fix-cmake-sikuli-ide.patch:
    + Fix random FTBFS due to missing inter target dependency

 -- Gilles Filippini <pini@debian.org>  Tue, 04 Oct 2011 23:32:13 +0200

sikuli (1.0~x~rc3-dfsg1-1) unstable; urgency=low

  * New upstream release:
    + Sikuli IDE
      - Auto indentation
      - New settings in preferences: expand tab, tab width, font style, font
        size
      - locale setting
      - ESC cancels screen capture mode
      - Sikuli code (including images) can be copied across tabs
      - Sikuli code can be copied as plain text to other programs/text
        editors
      - Window size and opened files are remembered and restored
        automatically
    + Sikuli Script
      - App class supports Linux now (wmctrl and xdotool required.)
      - Java APIs are more consistent with Jython's
      - New hotkey API allows the user to register hotkeys that trigger a
        Sikuli function
      - A parameter of Sikuli's vision engine MinTargetSize can be changed to
        adjust the robustness/speed of the engine
      - Pure color templates matching
      - popup() accepts an optional parameter for setting the title of the
        dialog
      - Some error messages are improved
    + Bug fixes
      - Closes: #642794.
      - Many bugs in the matching preview window are fixed - not hanging
        anymore, preview is consistent with the result of findAll.

  * orig.tar.gz:
    + drop extensions which should ship into their own source packages since
      they have their own versioning
  * debian/control
    + Multi-Arch support
    + libsikuli-script-java: Depends wmctrl, xdotool
  * debian/rules
    + Multi-Arch support
  * debian/copyright, debian/README.source:
    + More accurate information about how to download the source
    + Updated removed parts list

 -- Gilles Filippini <pini@debian.org>  Tue, 04 Oct 2011 00:57:09 +0200
