=== debian/control ===
Source: sikuli
Section: java
Priority: extra
Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Gilles Filippini <pini@debian.org>
Build-Depends: debhelper (>= 8.1.3~), javahelper, default-jdk (>= 1:1.6), cmake, jython, libcv-dev, libcvaux-dev, libhighgui-dev, libcommons-cli-java, junit, libswing-layout-java, libswingx-java, libjxgrabkey-java, libjgoodies-forms-java, libjson-simple-java, libmac-widgets-java, zip, exuberant-ctags, tesseract-ocr-dev, swig,
 default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libswingx-java-doc, libjxgrabkey-doc, libjgoodies-forms-java-doc, libjson-simple-doc, libmac-widgets-doc,
 python-sphinx
Standards-Version: 3.9.2
Homepage: http://sikuli.org
Vcs-Git: git://git.debian.org/collab-maint/sikuli.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sikuli.git;a=summary

Package: sikuli-ide
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-java, junit, libswingx-java
Description: IDE to develop sikuli scripts and use them a junit test cases
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features Sikuli IDE, the integrated development environment
 for writing visual scripts with screenshots.
 .
 sikuli-ide also provides junit integration for running sikuli scripts as
 junit test cases.

Package: libsikuli-script-java
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-jni, jython, wmctrl, xdotool
Suggests: libsikuli-script-doc
Description: Visual scripting API for jython
 Sikuli mixes image recognition into Jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features the jython sikuli visual scripting API and the sikuli
 script interpreter.

Package: libsikuli-script-jni
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Native libs for libsikuli-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package holds the architecture dependent jni backend of the java
 library.

Package: libsikuli-script-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-sphinxdoc
Recommends: default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libjxgrabkey-doc, libjson-simple-doc, libmac-widgets-doc
Description: Documentation for libsikuli-script-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package contains the javadoc API documentation for the java library
 libsikuli-script-java.
