## sikuli 1.0~x~rc3.tesseract3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT (sikuli)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/")
INCLUDE(${CMAKE_MODULE_PATH}/common.cmake)

ADD_SUBDIRECTORY(sikuli-script)
ADD_SUBDIRECTORY(sikuli-ide)

INCLUDE(CTest)
